require 'yaml'

require 'bogy/handler_manager'
require 'bogy/writeable'

class Bogy

  def initialize(options = {})
    # If user provides incorrect number of arguments (not one)
    raise ArgumentError, "wrong number of arguments (#{options.length} for 1)" unless options.length == 1

    @handler = HandlerManager.find_handler(options)
  end

  def [](key)
    @handler.hash[key]
  end

  def []=(key, value)
    @handler.hash[key] = value
    @handler.write if @handler.is_a? Writeable
  end

  def delete(key)
    deleted = @handler.hash.delete(key)
    @handler.write if @handler.is_a? Writeable
    deleted
  end

  def to_h
    @handler.hash
  end

  def to_yaml
    @handler.hash.to_yaml
  end

  def write_to_file(path)
    IO.write(path, @handler.hash.to_yaml)
  end

end
