require 'bogy/handler'

class Bogy

  ##
  # The handler manager contains information about all bogy handlers
  # It also find and return them

  module HandlerManager

    HANDLERS = [
      :file,
      :hash,
      :string
    ]

    def self.find_handler(options)
      options = options.shift
      handler_name, arg = options

      if HANDLERS.include? handler_name
        handler_instance(handler_name, arg)
      else
        raise ArgumentError, "invalid argument '#{handler_name}'"
      end
    end

    def self.handler_instance(handler_name, arg)
      handler_name = handler_name.to_s
      const_name = handler_name.capitalize << 'Handler'

      require "bogy/handlers/#{handler_name}_handler"
      Bogy.const_get(const_name).new(arg)
    end

  end
end
